class Get2 {
  static bool isLogEnable = true;
  Get2._internal();

  //////////// INSTANCE MANAGER
  static Map<dynamic, dynamic> _singl = {};

 

  /// Inject class on GIM
  static S put<S>(
    S value, {
    String name,
    _FcBuilderFunc<S> builder,
  }) {
    _register(isSingleton: true, name: name, builder: builder ?? (() => value));
    return find<S>(name: name);
  }

  /// Create a new instance from builder class
  /// Example
  /// Get.create(() => Repl());
  /// Repl a = Get.find();
  /// Repl b = Get.find();
  /// print(a==b); (false)
  static void create<S>(
    _FcBuilderFunc<S> builder, {
    String name,
  }) {
    _register(isSingleton: false, name: name, builder: builder);
  }

  static void _register<S>({
    bool isSingleton,
    String name,
    _FcBuilderFunc<S> builder,
  }) {
    assert(builder != null);
    String key = getKey(S, name);
    _singl[key] = _FcBuilder<S>(isSingleton, builder);
  }

  /// Find a instance from required class
  static S find<S>({String name}) {
    String key = getKey(S, name);
    _FcBuilder builder = _singl[key];
    if (builder == null) {
      if (name == null) {
        throw "class ${S.toString()} is not register";
      } else {
        throw "class ${S.toString()} with name '$name' is not register";
      }
    }
    return _singl[key].getSependency();
  }

  /// Remove dependency of [S] and maintain memory allocation
  static void remove<S>({String name}) {
    String key = getKey(S, name);
    _FcBuilder builder = _singl[key];
    if (builder != null) builder.dependency = null;
    if (_singl.containsKey(key)) {
      print('error on remove $key');
    } else {
      if (isLogEnable) print('[GET] $key removed from memory');
    }
  }

  static String getKey(Type type, String name) {
    return name == null ? type.toString() : type.toString() + name;
  }

  static bool reset() {
    _singl.clear();
    return true;
  }

  /// Delete class instance on [S] and clean memory
  static bool delete<S>({String name}) {
    String key = getKey(S, name);

    if (!_singl.containsKey(key)) {
      print('Instance $key not found');
      return false;
    }
    _singl.removeWhere((oldkey, value) => (oldkey == key));
    if (_singl.containsKey(key)) {
      print('error on remove object $key');
    } else {
      if (isLogEnable) print('[GET] $key deleted from memory');
    }
    return true;
  }

  /// check if instance is registred
  static bool isRegistred<S>({String name}) =>
      _singl.containsKey(getKey(S, name));
}

class _FcBuilder<S> {
  bool isSingleton;
  _FcBuilderFunc builderFunc;
  S dependency;

  _FcBuilder(this.isSingleton, this.builderFunc);

  S getSependency() {
    if (isSingleton) {
      if (dependency == null) {
        dependency = builderFunc() as S;
      }
      return dependency;
    } else {
      return builderFunc() as S;
    }
  }
}

typedef _FcBuilderFunc<S> = S Function();
